/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package alaposztalyok;

import java.awt.Graphics;
import java.awt.Image;
import java.util.logging.Level;
import java.util.logging.Logger;
import vezerles.Vezerlo;

/**
 *
 * @author :)
 */
public class Pillango extends Thread{
    
    private Image kep;
    private int kepX, kepY;
    private int kepSzelesseg, kepMagassag;
    private long ido;
    private int dx;
    private int dy;
    private boolean elkaptak;

    private boolean mukodik = true;
    
    private static int feluletSzelesseg, feluletMagassag;
    private Vezerlo vezerlo;

    public Pillango(Image kep, int kepX, int kepY, int kepSzelesseg, int kepMagassag, long ido, int dx, int dy, Vezerlo vezerlo) {
        this.kep = kep;
        this.kepX = kepX;
        this.kepY = kepY;
        this.kepSzelesseg = kepSzelesseg;
        this.kepMagassag = kepMagassag;
        this.ido = ido;
        this.dx = dx;
        this.dy = dy;
        this.vezerlo = vezerlo;
    }

    /**
     * kirajzolja a pillangót
     * @param g 
     */
    public void rajzolas(Graphics g){
        g.drawImage(kep, kepX, kepY, kepSzelesseg, kepMagassag, null);
    }

    /**
     * addig mozgatja, amíg a felület fölött van, vagy el nem kapták.
     */
    public void run() {
        while (kepX > -kepSzelesseg && kepX < feluletSzelesseg
                && kepY > -kepMagassag && kepY < feluletMagassag
                && !elkaptak) {

            try {
                kepX += dx;
                kepY += dy;
                vezerlo.frissit();

                Thread.sleep(ido);
            } catch (InterruptedException ex) {
                Logger.getLogger(Pillango.class.getName()).log(Level.SEVERE, null, ex);
                return;
            }
        }
        if (elkaptak) {
            vezerlo.torol(this);
        }
    }
 
    /**
     * Megvizsgálja, hogy elkapták-e az adott pontban.
     * @param x
     * @param y 
     */
    public void megfogtak(int x, int y) {
//        if(kepX < x && x < kepX + kepSzelesseg &&
//                kepY < y && y < kepY + kepMagassag){
//            elkaptak = true;
//        }
        elkaptak = (kepX < x && x < kepX + kepSzelesseg &&
                kepY < y && y < kepY + kepMagassag);
    }
    
    public static int getFeluletSzelesseg() {
        return feluletSzelesseg;
    }

    public static void setFeluletSzelesseg(int feluletSzelesseg) {
        Pillango.feluletSzelesseg = feluletSzelesseg;
    }

    public static int getFeluletMagassag() {
        return feluletMagassag;
    }

    public static void setFeluletMagassag(int feluletMagassag) {
        Pillango.feluletMagassag = feluletMagassag;
    }    

    public boolean isMukodik() {
        return mukodik;
    }

    public void setMukodik(boolean mukodik) {
        this.mukodik = mukodik;
    }
}